var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, ElementRef, ViewChild, ViewEncapsulation, EventEmitter } from '@angular/core';
import * as anim from 'css-animation';
import { BooleanFieldValue } from '../../utils';
var Alert = (function () {
    function Alert() {
        this.onClose = new EventEmitter();
        this.closing = true;
        this.closed = false;
        this.alertClass = {};
        this.iconType = '';
        this.prefixCls = 'ant-alert';
    }
    Alert.prototype.handleClose = function (e) {
        var _this = this;
        e.preventDefault();
        this.closing = false;
        this.onClose.emit(e);
        anim(this.animateEle.nativeElement, this.prefixCls + "-slide-up-leave", function () {
            _this.closed = true;
            _this.closing = true;
            _this.render();
        });
    };
    Alert.prototype.render = function () {
        this.showIcon = this.banner && this.showIcon === undefined ? true : this.showIcon;
        this.type = this.banner && this.type === undefined ? 'warning' : this.type || 'info';
        var iconType = '';
        switch (this.type) {
            case 'success':
                iconType = 'check-circle';
                break;
            case 'info':
                iconType = 'info-circle';
                break;
            case 'error':
                iconType = 'cross-circle';
                break;
            case 'warning':
                iconType = 'exclamation-circle';
                break;
            default:
                iconType = 'default';
        }
        if (!!this.description) {
            iconType += '-o';
        }
        this.iconType = iconType;
        var prefixCls = this.prefixCls;
        this.alertClass = (_a = {
                'ant-alert': true
            },
            _a[prefixCls + "-" + this.type] = true,
            _a[prefixCls + "-close"] = !this.closing,
            _a[prefixCls + "-with-description"] = !!this.description,
            _a[prefixCls + "-no-icon"] = !this.showIcon,
            _a[prefixCls + "-banner"] = !!this.banner,
            _a);
        // closeable when closeText is assigned
        if (this.closeText) {
            this.closable = true;
        }
        var _a;
    };
    Alert.prototype.ngOnInit = function () {
        this.render();
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], Alert.prototype, "type", void 0);
    __decorate([
        Input(), BooleanFieldValue(),
        __metadata("design:type", Boolean)
    ], Alert.prototype, "closable", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], Alert.prototype, "closeText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], Alert.prototype, "message", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], Alert.prototype, "description", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], Alert.prototype, "showIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], Alert.prototype, "banner", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], Alert.prototype, "onClose", void 0);
    __decorate([
        ViewChild('animateEle'),
        __metadata("design:type", ElementRef)
    ], Alert.prototype, "animateEle", void 0);
    Alert = __decorate([
        Component({
            selector: 'Alert',
            encapsulation: ViewEncapsulation.None,
            templateUrl: './template.html',
            styleUrls: [
                './style.less'
            ]
        })
    ], Alert);
    return Alert;
}());
export { Alert };
//# sourceMappingURL=component.js.map