import {
  Component,
  ViewEncapsulation,
  Input,
  OnInit
} from '@angular/core'
import { BooleanFieldValue } from '../../utils'

@Component({
  selector: 'Icon',
  encapsulation: ViewEncapsulation.None,
  template: '<i [ngClass]="iconClass"></i>',
  styleUrls: [
    './style.less'
  ]
})
export class Icon implements OnInit {
  @Input() type: string
  @Input() @BooleanFieldValue() spin: boolean

  iconClass = {}

  private render() {
    this.iconClass = {
      anticon: true,
      'anticon-spin': !!this.spin || this.type === 'loading',
      [`anticon-${this.type}`]: true
    }
  }
  ngOnInit() {
    this.render()
  }
}
